package com.example.demo.config;
import com.baomidou.dynamic.datasource.toolkit.DynamicDataSourceContextHolder;
import org.aspectj.lang.annotation.AfterReturning;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.springframework.core.Ordered;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;
@Aspect
@Order(Ordered.LOWEST_PRECEDENCE - 1)
@Component
public class DataSourceInterceptor {
    @Before("execution(* *..dao.*.select*(..)) " +
            "|| execution(* *..dao.*.get*(..)) " +
            "|| execution(* *..dao.*.count*(..)) " +
            "|| execution(* *..service.*.list*(..))")
    public void setReadDataSourceType() {
        DynamicDataSourceContextHolder.push("slave");
        System.out.println("dataSource切换到：slave");
    }
    @Before("execution(* *..dao.*.insert*(..)) " +
            "|| execution(* *..dao.*.update*(..)) " +
            "|| execution(* *..dao.*.delete*(..)) " +
            "|| execution(* *..dao.*.add*(..)) " +
            "|| execution(* *..dao.*.save*(..))")
    public void setWriteDataSourceType() {
        DynamicDataSourceContextHolder.push("master");
        System.out.println("dataSource切换到：master");
    }
    @AfterReturning("execution(* *..service.*.*(..))")
    public void clearDataSourceType() {
        DynamicDataSourceContextHolder.clear();
    }
}